/**********************************************************
ITU4ŃNbNM̂gԃf[eB𑪒肷B
܂ITU3ŔCӂ̃f[eB茟؂

ITU4inputcapture@iƂgԒ𑪒j
ITU3PWMifor debugj

ݒ
ITU4̃CvbgLv`{obt@gp
TIOCATIOCBɓM
GRA͗GbWŃCvbgLv`
GRB͗ŃCvbgLv`
CvbgLv`BŃJE^NA
CvbgLv`BŊ荞
荞ݎɂ
@BRAHighԂ̒
@GRBɎ
̂Qf[eB䂪킩

				   Time Chart
TIOCA  ______|~~~~~~~~~~|_____________|~~~~~~~~~~|___
			 ^P1        ^Q1           ^P2        ^Q2
TCNT         CLR > > up > > > > > > > CLR > > up >
GRA          |  N at P1 |    N at Q1  |  N at P2 |
BRA          |  N at Q0 |    N at P1  |  N at Q1 |
GRB          |   N at P1              |  N at P2   
			  ^interrupt               ^interrupt

**********************************************************/
#include <3048fone.h>
#include "h8_3048fone.h"

/*clockindex   0:ӁC1:/2C2:/4C3:/8*/
/*pwmmax                                   */
/*    10      0.4     0.8     1.6      3.2 [sec]*/
/*    20      0.8     1.6     3.2      6.4 */
/*    50      2       4       8       16   */
/*   100      4       8      16       32   */
/*   200      8      16      32       64   */
/*   500     20      40      80      160   */
/*  1000     40      80     160      320   */
/*  2000     80     160     320      640   */
/*  5000    200     400     800     1600   */
/* 10000    400     800    1600     3200   */
/* 20000    800    1600    3200     6400   */
/* 50000   2000    4000    8000    16000   */

/*
荞݃xN^@IMIB4 41 0xA4-0xA7

͒[q 肵g`Cȉ̂Q̒[qɓ͂
@4 TIOCA4/TP10/PB2 CN1-18
@5 TIOCB4/TP11/PB3 CN1-19
*/
/*f[eB䑪̂߂̏*/
void initMeasDuty(int clockindex)
{
	ITU4.TCR.BIT.TPSC=clockindex; /*0:ӁC1:/2C2:/4C3:/8*/
	ITU4.TCR.BIT.CCLR=2; /*GRB̃CvbgLv`ŃJE^NA*/
	ITU4.TIOR.BIT.IOA=7; /*GRA͗^̗GbWŃCvbgLv`*/
	ITU4.TIOR.BIT.IOB=4; /*GRB͗̃GbWŃCvbgLv`*/
	ITU.TFCR.BIT.BFA4=1; /*GRA4BRA4̓obt@*/
	ITU4.TSR.BIT.IMFB=0; /*GRBRyA}b`tbONA*/
	ITU4.TIER.BIT.IMIEB=1; /*IMFBtOɂ銄݂*/
	ITU.TSTR.BIT.STR4=1; /*ITU4X^[g*/
}

#define readPeriod() (ITU4.GRB)
#define readHigh() (ITU4.BRA)

/*pPWMo*/
/*o͒[q@2 ITOCA3/PB0    CN1-16*/

/*ITU channel3 PWMo*/
void initPWM3(unsigned short int pwmmax, int clockindex)
{
	ITU3.TCR.BIT.TPSC=clockindex;  /*NbNӂŃJEg*/
	ITU3.TCR.BIT.CKEG=0;  /*オGbWŃJEg*/
	ITU3.TCR.BIT.CCLR=1;  /*GRÃRyA}b`TCNTNA*/
	ITU3.GRA=pwmmax-1;    /*GRA̒l(GRB=GRÂƂPWM100%)PWM_MAXɐݒ*/
	ITU3.GRB=0;           /*GRB̒l0ɐݒ(=PWM0%)pX͂̒lɈˑ*/
	ITU.TMDR.BIT.PWM3=1;  /*ITUPWMɎgchPWM[hɐݒ*/
	ITU3.TIOR.BIT.IOB=0;  /*TIOCBPWMMo͂Ȃ悤ɐݒ*/
	ITU.TSTR.BIT.STR3=1;  /*JEgX^[g(PWMMo͂)*/
}

/*PWMo*/
void outPWM3(unsigned int value)
{
	if (value) {
		ITU3.TCR.BIT.CCLR=1;  /*GRÃRyA}b`TCNTNA*/
		value--;
		if (ITU3.GRA==value) value++;
		ITU3.GRB=value;
	} else {
		ITU3.TCR.BIT.CCLR=2;  /*GRB̃RyA}b`TCNTNA*/
	}
}

volatile unsigned short int period=9999;
volatile unsigned short int high=0;

main()
{
	int keyhit;
	unsigned short int pwmvalue=1000;
	unsigned short int oldperiod=9999;
	unsigned short int oldhigh=0;
	initSCI1();
	initPWM3(2000, 3); /*clock:/8 1msec*/
	outPWM3(pwmvalue); /*f[eB1000/2000i50j*/
	initMeasDuty(3); /*clock:/8*/
	E_INT();        /*CPU荞݋*/
	SCI1_printf("\n\n\nDuty Ratio Measurement Check Program\n");
	SCI1_printf("Connect CN1-16,18,19.\n");
	SCI1_printf("Key [D] decrease PWM duty ratio down to 10%%.\n");
	SCI1_printf("Key [U] increase PWM duty ratio up to 90%%.\n");
	SCI1_printf("pwmmax=2000\n");
	while(1) {
		if (period!=oldperiod||high!=oldhigh) {
			SCI1_printf("pwm,high,period=%6d : %6u/%6u\n",pwmvalue,high,period);
			oldperiod=period;
			oldhigh=high;
		}
		if (0<(keyhit=chkgetCharSCI1())) {
			switch (keyhit) {
			case 'D':case 'd':
				if (200<pwmvalue) pwmvalue-=200;
				break;
			case 'U':case 'u':
				if (pwmvalue<1800) pwmvalue+=200;
				break;
			}
			outPWM3(pwmvalue);
			SCI1_printf("\n");
		}
	}
}


#pragma asm
	.SECTION    MYVEC, DATA, LOCATE=H'0000A4
	.ORG H'0000A4  ; ITU4CvbgLv`B荞݃xN^AhX
	.DATA.L _int_IMIB4
	.SECTION    P,CODE,ALIGN=2 ;YĂ͂Ȃ
#pragma endasm

#pragma interrupt (int_IMIB4)
void int_IMIB4() /*CvbgLv`B荞݃[`*/
{
	ITU4.TSR.BIT.IMFB=0; /*GRBRyA}b`tbONA*/
	period=readPeriod();
	high=readHigh();
}

/************************************************************
Duty Ratio Measurement Check Program
Connect CN1-16,18,19.
Key [D] decrease PWM duty ratio down to 10%.
Key [U] increase PWM duty ratio up to 90%.
pwmmax=2000
pwm,high,period=  1000 :   1000/  2000
u
pwm,high,period=  1200 :   1200/  2000
u
pwm,high,period=  1400 :   1400/  2000
u
pwm,high,period=  1600 :   1600/  2000
u
pwm,high,period=  1800 :   1800/  2000
d
pwm,high,period=  1600 :   1600/  2000
d
pwm,high,period=  1400 :   1400/  2000
d
pwm,high,period=  1200 :   1200/  2000
d
pwm,high,period=  1000 :   1000/  2000
d
pwm,high,period=   800 :    800/  2000
d
pwm,high,period=   600 :    600/  2000
d
pwm,high,period=   400 :    400/  2000
d
pwm,high,period=   200 :    200/  2000
u
pwm,high,period=   400 :    400/  2000
u
pwm,high,period=   600 :    600/  2000
u
pwm,high,period=   800 :    800/  2000
u
pwm,high,period=  1000 :   1000/  2000
u
pwm,high,period=  1200 :   1200/  2000
u
pwm,high,period=  1400 :   1400/  2000
u
pwm,high,period=  1600 :   1600/  2000
u
pwm,high,period=  1800 :   1800/  2000
************************************************************/
